/*
 * leastsquaremin.hpp
 *
 *  Created on: Aug 18, 2009
 *      Author: heber
 */

#ifndef LEASTSQUAREMIN_HPP_
#define LEASTSQUAREMIN_HPP_

using namespace std;

/*********************************************** includes ***********************************/

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <gsl/gsl_vector.h>

/****************************************** forward declarations *****************************/

class element;
class molecule;
class Vector;

/********************************************** declarations *******************************/

/** Parameter structure for least square minimsation.
 */
struct LSQ_params {
  const Vector **vectors;
  int num;
};

double LSQ(const gsl_vector * const x, void * params);

/** Parameter structure for least square minimsation.
 */
struct lsq_params {
  gsl_vector *x;
  const molecule *mol;
  const element *type;
};



#endif /* LEASTSQUAREMIN_HPP_ */
